DELIMITER $$
drop function if exists get_token;
$$
CREATE FUNCTION get_token( mac VARCHAR(50), date DATETIME ) RETURNS varchar(50) CHARSET utf8
NO SQL
BEGIN

	SET @token=MD5(CONCAT(SUBSTRING(mac,5,6), mac, SUBSTRING(date,1,4), SUBSTRING(mac,3,7), SUBSTRING(date,4,1), date, SUBSTRING(mac,3,10), SUBSTRING(date,12,6)));

RETURN @token;
END$$

DELIMITER $$
drop function if exists xml_entity_decode;
$$
CREATE FUNCTION xml_entity_decode( xml VARCHAR(5000) ) RETURNS varchar(5000) CHARSET utf8
NO SQL
BEGIN
	SET xml=REPLACE(REPLACE(REPLACE(REPLACE(xml, '&lt;', '<'), '&gt;', '>'), '&amp;', '&'), '&quot;', '"');
RETURN xml;
END$$

DELIMITER $$
drop function if exists xml_entity_encode;
$$
CREATE FUNCTION xml_entity_encode( xml VARCHAR(5000) ) RETURNS varchar(5000) CHARSET utf8
NO SQL
BEGIN
	SET xml=REPLACE(REPLACE(REPLACE(REPLACE(xml, '<', '&lt;'), '>', '&gt;'), '&', '&amp;'), '"', '&quot;');
RETURN xml;
END$$


DELIMITER $$
DROP FUNCTION IF EXISTS json_extract_1
$$
CREATE FUNCTION json_extract_1(json_txt TEXT, search_key VARCHAR (255)) 
    RETURNS TEXT
NO SQL
BEGIN
    RETURN (SELECT TRIM(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(txt,':',-1), '"', 2), '"', -1)) AS val
    FROM (
        SELECT TRIM(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX( SUBSTRING_INDEX(json_txt , ',', n), ',',  -1 ), '}', 1), '{', -1)) AS txt
        FROM (SELECT t1.v + t2.v*10 + t3.v*100 AS n
            FROM (SELECT 0 AS v UNION ALL SELECT 1 UNION ALL SELECT 2 UNION ALL SELECT 3 UNION ALL SELECT 4 UNION ALL SELECT 5 UNION ALL SELECT 6 UNION ALL SELECT 7 UNION ALL SELECT 8 UNION ALL SELECT 9) t1,
            (SELECT 0 AS v UNION ALL SELECT 1 UNION ALL SELECT 2 UNION ALL SELECT 3 UNION ALL SELECT 4 UNION ALL SELECT 5 UNION ALL SELECT 6 UNION ALL SELECT 7 UNION ALL SELECT 8 UNION ALL SELECT 9) t2,
            (SELECT 0 AS v UNION ALL SELECT 1 UNION ALL SELECT 2 UNION ALL SELECT 3 UNION ALL SELECT 4 UNION ALL SELECT 5 UNION ALL SELECT 6 UNION ALL SELECT 7 UNION ALL SELECT 8 UNION ALL SELECT 9) t3) numbers
        WHERE CHAR_LENGTH(json_txt ) - CHAR_LENGTH(REPLACE(json_txt , ',', '')) >= n - 1
        AND n>0 ) sp
    WHERE TRIM(SUBSTRING_INDEX(txt,':',1)) = CONCAT('"',search_key,'"')
    LIMIT 1   -- comment out for safe mode
    );
END$$


DELIMITER $$
drop function if exists get_location_routes;
$$
CREATE FUNCTION `get_location_routes`(varIdLocationParent INT) RETURNS json
BEGIN
    DECLARE json_result JSON;
	SET @r := varIdLocationParent;
		SET @l := 0;
		
		SET json_result = (
			SELECT JSON_ARRAYAGG(
				JSON_OBJECT('id', T2.id, 'name', T2.`name`, 'idLayer', T2.idLayer)
			)
			FROM (
				SELECT
					@r AS _id,
					(SELECT @r := idparent FROM `mdm_premises_locations` WHERE id = _id) AS idparent,
					@l := @l + 1 AS lvl
				FROM
					(SELECT @r := varIdLocationParent, @l := 0) vars,
					`mdm_premises_locations` m
				WHERE @r <> 0) T1
			JOIN `mdm_premises_locations` T2 ON T1._id = T2.id
			ORDER BY T1.lvl DESC
		);

	RETURN json_result;
END$$

show function status;
